"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _quickNDirtyReact = require("quick-n-dirty-react");

var _quickNDirtyUtils = _interopRequireDefault(require("quick-n-dirty-utils"));

var _CsvHandler = _interopRequireDefault(require("./CsvHandler"));

var _CsvVisualiser = _interopRequireDefault(require("./CsvVisualiser"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var style = {
  columns: function columns(numberOfColumns) {
    return {
      display: "grid",
      gridTemplateColumns: "repeat(".concat(numberOfColumns, ", 1fr)"),
      gridColumnGap: "2px",
      marginBottom: "2px"
    };
  },
  value: {
    padding: "2px 4px",
    fontFamily: "monospace",
    fontSize: "11px"
  },
  numberOfRows: _objectSpread(_objectSpread(_objectSpread({}, _quickNDirtyReact.mixins.listHeader), _quickNDirtyReact.mixins.center), {}, {
    fontStyle: "italic",
    border: "0px",
    fontWeight: "400"
  })
};

var CsvForm = /*#__PURE__*/function (_React$Component) {
  _inherits(CsvForm, _React$Component);

  var _super = _createSuper(CsvForm);

  function CsvForm(props) {
    var _this;

    _classCallCheck(this, CsvForm);

    _this = _super.call(this, props);
    _this.state = {
      rawCsv: null,
      hasHeader: false,
      csvColumns: [],
      data: []
    };
    _this.onFileChange = _this.onFileChange.bind(_assertThisInitialized(_this));
    _this.setHasHeader = _this.setHasHeader.bind(_assertThisInitialized(_this));
    _this.setCsvColumns = _this.setCsvColumns.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(CsvForm, [{
    key: "onFileChange",
    value: function onFileChange(ev) {
      var _this2 = this;

      var file = ev.target.files[0]; // first reset the components data

      this.setState({
        rawCsv: null,
        csvColumns: []
      }, function () {
        // then parse the data
        _CsvHandler["default"].parseCsvFile(file).then(function (rawCsv) {
          // set raw CSV
          _this2.setState({
            rawCsv: rawCsv
          }, function () {
            _this2.setCsvColumns();
          });
        });
      });
    }
  }, {
    key: "setCsvColumns",
    value: function setCsvColumns() {
      if (this.state.rawCsv == null || !Array.isArray(this.state.rawCsv) || this.state.rawCsv.length === 0) {
        // abort condition
        return;
      }

      if (!this.state.hasHeader) {
        // has no header, so we're just using indices
        this.setState(function (oldState) {
          return _objectSpread(_objectSpread({}, oldState), {}, {
            csvColumns: _quickNDirtyUtils["default"].range(0, oldState.rawCsv[0].length - 1),
            data: _toConsumableArray(oldState.rawCsv)
          });
        });
      } else {
        this.setState(function (oldState) {
          return _objectSpread(_objectSpread({}, oldState), {}, {
            csvColumns: oldState.rawCsv[0],
            data: _toConsumableArray(oldState.rawCsv).slice(1)
          });
        });
      }
    }
  }, {
    key: "setHasHeader",
    value: function setHasHeader(ev) {
      var _this3 = this;

      var hasHeader = ev.target.checked; // update hasHeader state

      this.setState({
        hasHeader: hasHeader
      }, function () {
        // reset CSV columns
        _this3.setCsvColumns();
      });
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("label", {
        style: _quickNDirtyReact.mixins.label
      }, "CSV File"), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("input", {
        type: "file",
        accept: ".csv",
        onChange: this.onFileChange
      })), this.state.rawCsv != null ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
        style: _quickNDirtyReact.mixins.vSpacer(8)
      }), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("input", {
        type: "checkbox",
        style: _quickNDirtyReact.mixins.checkbox,
        onChange: this.setHasHeader,
        checked: this.state.hasHeader,
        id: "csv-form-has-header"
      }), /*#__PURE__*/_react["default"].createElement("label", {
        htmlFor: "csv-form-has-header"
      }, "Has Header")), /*#__PURE__*/_react["default"].createElement("div", {
        style: _quickNDirtyReact.mixins.vSpacer(8)
      }), /*#__PURE__*/_react["default"].createElement("div", {
        style: style.columns(this.state.csvColumns.length)
      }, this.state.csvColumns.map(function (col) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: col,
          style: _quickNDirtyReact.mixins.listHeader
        }, col);
      })), this.state.data.length > 0 ? this.state.data.slice(0, 5).map(function (row, idx) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: idx,
          style: style.columns(row.length)
        }, row.map(function (col, colIdx) {
          return /*#__PURE__*/_react["default"].createElement("div", {
            key: colIdx,
            style: style.value
          }, col);
        }));
      }) : null, this.state.data.length > 0 ? /*#__PURE__*/_react["default"].createElement("div", {
        style: style.numberOfRows
      }, this.state.data.length, " rows") : null, this.props.showData !== false ? /*#__PURE__*/_react["default"].createElement(_CsvVisualiser["default"], {
        data: this.state.data,
        csvColumns: this.state.csvColumns,
        layout: this.props.layout
      }) : null) : null);
    }
  }]);

  return CsvForm;
}(_react["default"].Component);

var _default = CsvForm;
exports["default"] = _default;