"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _reactPlotly = _interopRequireDefault(require("react-plotly.js"));

var _quickNDirtyReact = require("quick-n-dirty-react");

var _quickNDirtyUtils = _interopRequireDefault(require("quick-n-dirty-utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var style = {
  columnMapping: {
    display: "grid",
    gridTemplateColumns: "250px 150px 200px",
    gridColumnGap: "5px",
    marginBottom: "8px"
  },
  mappingLabel: _objectSpread(_objectSpread({}, _quickNDirtyReact.mixins.right), {}, {
    padding: "7px 5px"
  })
};
var DEFAULT_DATE_FORMAT = _quickNDirtyUtils["default"].DATE_FORMAT;
var DEFAULT_COLUMN_MAPPING = {
  type: "value",
  format: "int"
};
var DEFAULT_LAYOUT = {
  width: 1000,
  height: 450
};

var CsvVisualiser = /*#__PURE__*/function (_React$Component) {
  _inherits(CsvVisualiser, _React$Component);

  var _super = _createSuper(CsvVisualiser);

  function CsvVisualiser(props) {
    var _this;

    _classCallCheck(this, CsvVisualiser);

    _this = _super.call(this, props);
    _this.state = {
      chartData: null,
      columnMapping: {}
    };
    _this.setColumnFormat = _this.setColumnFormat.bind(_assertThisInitialized(_this));
    _this.setColumnType = _this.setColumnType.bind(_assertThisInitialized(_this));
    _this.showData = _this.showData.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(CsvVisualiser, [{
    key: "setColumnFormat",
    value: function setColumnFormat(column) {
      var _this2 = this;

      return function (ev) {
        var format = ev.target.value;

        _this2.setState(function (oldState) {
          var columnMapping = oldState.columnMapping;
          columnMapping[column] = {
            type: ["int", "float"].includes(format) ? "value" : "datetime",
            format: format
          };
          return _objectSpread(_objectSpread({}, oldState), {}, {
            columnMapping: columnMapping
          });
        });
      };
    }
  }, {
    key: "setColumnType",
    value: function setColumnType(column) {
      var _this3 = this;

      return function (ev) {
        var type = ev.target.value;

        _this3.setState(function (oldState) {
          var columnMapping = oldState.columnMapping;
          columnMapping[column] = {
            type: type,
            format: type === "datetime" ? DEFAULT_DATE_FORMAT : "int"
          };
          return _objectSpread(_objectSpread({}, oldState), {}, {
            columnMapping: columnMapping
          });
        });
      };
    }
  }, {
    key: "showData",
    value: function showData() {
      var _this4 = this;

      this.setState({
        chartData: null
      }, function () {
        var x = [];
        var ys = {};
        var specs = {}; // initialise y keys

        _this4.props.csvColumns.forEach(function (col) {
          var spec = _this4.state.columnMapping[col] || DEFAULT_COLUMN_MAPPING;
          specs[col] = spec;

          if (spec.type !== "datetime") {
            ys[col] = [];
          }
        }); // process rows


        _this4.props.data.forEach(function (row) {
          _this4.props.csvColumns.forEach(function (col, colIdx) {
            if (specs[col].type === "datetime") {
              // add x time
              x.push((0, _moment["default"])(row[colIdx], specs[col].format)._d);
            } else if (specs[col].format === "float") {
              ys[col].push(parseFloat(row[colIdx]));
            } else {
              // integer value
              ys[col].push(parseInt(row[colIdx], 10));
            }
          });
        }); // create chart data


        var charts = [];
        var chartType = x.length * Object.keys(ys).length < 30 ? "bar" : "line";

        _this4.props.csvColumns.forEach(function (col) {
          if (specs[col].type === "datetime") {
            // skip the datetime column
            return;
          }

          charts.push({
            x: x,
            y: ys[col],
            type: chartType,
            name: col
          });
        });

        _this4.setState({
          chartData: charts
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("h5", null, "Column Mapping"), /*#__PURE__*/_react["default"].createElement("div", {
        style: style.columnMapping
      }, /*#__PURE__*/_react["default"].createElement("div", {
        style: _quickNDirtyReact.mixins.listHeader
      }, "Column"), /*#__PURE__*/_react["default"].createElement("div", {
        style: _quickNDirtyReact.mixins.listHeader
      }, "Type"), /*#__PURE__*/_react["default"].createElement("div", {
        style: _quickNDirtyReact.mixins.listHeader
      }, "Format")), this.props.csvColumns.map(function (col) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: col,
          style: style.columnMapping
        }, /*#__PURE__*/_react["default"].createElement("div", {
          style: style.mappingLabel
        }, col), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("select", {
          style: _quickNDirtyReact.mixins.dropdown,
          onChange: _this5.setColumnType(col),
          value: _this5.state.columnMapping[col] ? _this5.state.columnMapping[col].type : "value"
        }, /*#__PURE__*/_react["default"].createElement("option", {
          value: "datetime"
        }, "Date/Time"), /*#__PURE__*/_react["default"].createElement("option", {
          value: "value"
        }, "Numeric Value"))), /*#__PURE__*/_react["default"].createElement("div", null, _this5.state.columnMapping[col] != null && _this5.state.columnMapping[col].type === "datetime" ? /*#__PURE__*/_react["default"].createElement("input", {
          type: "text",
          style: _quickNDirtyReact.mixins.textInput,
          value: _this5.state.columnMapping[col].format,
          onChange: _this5.setColumnFormat(col)
        }) : /*#__PURE__*/_react["default"].createElement("select", {
          style: _quickNDirtyReact.mixins.dropdown,
          onChange: _this5.setColumnFormat(col),
          value: _this5.state.columnMapping[col] ? _this5.state.columnMapping[col].format : "int"
        }, /*#__PURE__*/_react["default"].createElement("option", {
          value: "int"
        }, "Integer"), /*#__PURE__*/_react["default"].createElement("option", {
          value: "float"
        }, "Decimal"))));
      }), /*#__PURE__*/_react["default"].createElement("div", {
        style: _quickNDirtyReact.mixins.buttonLine
      }, /*#__PURE__*/_react["default"].createElement("button", {
        style: _quickNDirtyReact.mixins.button,
        type: "button",
        onClick: this.showData
      }, "Show")), this.state.chartData != null ? /*#__PURE__*/_react["default"].createElement(_reactPlotly["default"], {
        data: this.state.chartData,
        layout: _objectSpread(_objectSpread({}, this.props.layout), DEFAULT_LAYOUT)
      }) : null);
    }
  }]);

  return CsvVisualiser;
}(_react["default"].Component);

var _default = CsvVisualiser;
exports["default"] = _default;